SoNurbsSurface(3)

NAME
SoNurbsSurface - The SoNurbsSurface class is used to render smooth surfaces.

SYNOPSIS

#include <Inventor/nodes/SoNurbsSurface.h>

Inherits SoShape.

  Public Member Functions
virtual SoType getTypeId (void) const
SoNurbsSurface (void)
virtual void GLRender (SoGLRenderAction *action)
virtual void rayPick (SoRayPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
void sendPrimitive (SoAction *, SoPrimitiveVertex *)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Public Attributes
SoSFInt32 numUControlPoints
SoSFInt32 numVControlPoints
SoSFInt32 numSControlPoints
SoSFInt32 numTControlPoints
SoMFFloat uKnotVector
SoMFFloat vKnotVector
SoMFFloat sKnotVector
SoMFFloat tKnotVector

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoNurbsSurface ()
virtual void generatePrimitives (SoAction *action)
virtual void computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
SoDetail * createTriangleDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, const SoPrimitiveVertex *v3, SoPickedPoint *pp)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoNurbsSurface class is used to render smooth surfaces. A general explanation of NURBS is beyond the scope of the Coin documentation. For detailed information, refer to the specialized literature on the topic (for example 'An Introduction to NURBS: With Historical Perspective' by David F. Rogers). A basic overview of curve and surface rendering using NURBS can be found in chapter 8 of 'The Inventor Mentor'.

Note that knot values should be specified as [0, 1, 2,..., a] rather than [0, 1/a, 2/a,..., 1] to avoid tessellation errors due to floating point precision problems. (Even if the rendered surface looks correct, such issues might surface when e.g. doing picking, since the tessellated representation used internally is not the same as the one you see rendered by OpenGL on-screen.)

Each control point has a weight that changes the shape of its basis function. Weight is analogous to having magnets pulling on the curve. Coordinate3 sets control points to have an equal weight of 1.0 (nonrational). Use Coordinate4 to specify x, y, z and weight values (rational).

A basic usage example:

#Inventor V2.1 ascii
ShapeHints {
  vertexOrdering COUNTERCLOCKWISE
}
Coordinate3 {
   point [
     -3 -3 -3, -3 -1 -3, -3  1 -3, -3  3 -3,
     -1 -3 -3, -1 -1  3, -1  1  3, -1  3 -3,
      1 -3 -3,  1 -1  3,  1  1  3,  1  3 -3,
      3 -3 -3,  3 -1 -3,  3  1 -3,  3  3 -3
    ]
}
NurbsSurface {
   numUControlPoints 4
   numVControlPoints 4
   uKnotVector [ 0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0 ]
   vKnotVector [ 0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0 ]
}

 Rendering of Example Scenegraph

FILE FORMAT/DEFAULTS:

NurbsSurface {
    numUControlPoints 0
    numVControlPoints 0
    numSControlPoints 0
    numTControlPoints 0
    uKnotVector 0
    vKnotVector 0
    sKnotVector 0
    tKnotVector 0
}

Constructor & Destructor Documentation

  SoNurbsSurface::SoNurbsSurface (void)
Constructor.

  SoNurbsSurface::~SoNurbsSurface () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoNurbsSurface::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoNurbsSurface::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoShape.

  const SoFieldData ** SoNurbsSurface::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoNurbsSurface::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoShape.

  void SoNurbsSurface::initClass (void) [static]

  void SoNurbsSurface::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShape.

  void SoNurbsSurface::rayPick (SoRayPickAction * action) [virtual]
Calculates picked point based on primitives generated by subclasses.

Reimplemented from SoShape.

  void SoNurbsSurface::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoShape.

  void SoNurbsSurface::sendPrimitive (SoAction *, SoPrimitiveVertex *)
This method is part of the original SGI Inventor API, but not implemented in Coin, as it looks like a method that should probably have been private in Open Inventor.

  void SoNurbsSurface::generatePrimitives (SoAction * action) [protected], [virtual]
The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

  void SoNurbsSurface::computeBBox (SoAction * action, SbBox3f & box, SbVec3f & center) [protected], [virtual]
Calculates the bounding box of all control points, and sets the center to the average of these points.

Implements SoShape.

  SoDetail * SoNurbsSurface::createTriangleDetail (SoRayPickAction * action, const SoPrimitiveVertex * v1, const SoPrimitiveVertex * v2, const SoPrimitiveVertex * v3, SoPickedPoint * pp) [protected], [virtual]
Will create triangle detail for a SoPickedPoint. This method will only be called internally, when generatePrimitives() is used for picking (SoShape::rayPick() is not overridden).

This method returns NULL in Open Inventor, and subclasses will need to override this method to create details for a SoPickedPoint.

This is not necessary with Coin. Of course, if you choose to override it, it will work in the same way as Open Inventor.

For this to work, you must supply a face or line detail when generating primitives. If you supply NULL for the detail argument in SoShape::beginShape(), you'll have to override this method.

Reimplemented from SoShape.

Member Data Documentation

  SoSFInt32 SoNurbsSurface::numUControlPoints
Number of control points in the U direction.

  SoSFInt32 SoNurbsSurface::numVControlPoints
Number of control points in the V direction.

  SoSFInt32 SoNurbsSurface::numSControlPoints
Number of control points in the S direction.

  SoSFInt32 SoNurbsSurface::numTControlPoints
Number of control points in the T direction.

  SoMFFloat SoNurbsSurface::uKnotVector
The Bezier knot vector for the U direction.

  SoMFFloat SoNurbsSurface::vKnotVector
The Bezier knot vector for the V direction.

  SoMFFloat SoNurbsSurface::sKnotVector
The Bezier knot vector for the S direction.

  SoMFFloat SoNurbsSurface::tKnotVector
The Bezier knot vector for the T direction.

Author

Generated automatically by Doxygen for Coin from the source code.